#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/uio.h>   
#include <unistd.h>

#include "sockrtns.h"

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

/*
   Implements a very simple server.
   syntax: server command [command options]

   Everytime an incoming connection is accepted, it is hooked up to 
   stdin, and the command called with its arguments. Whatever that
   command outputs goes to the client at the other end of the 
   connection.
*/

int main(int argc, char *argv[])
{
    int		s, port;
    int		incomingSock;
    int		size;	
    char	buffer[2048];
    
    struct  in_addr clientAddress;
    int	 	addressLength = sizeof(clientAddress);
        
    if (argc < 3)
    {
	fprintf(stderr, "usage: %s port command [command options]\n", argv[0]);
	fprintf(stderr, "e.g.: %s 3333 ls -l\n", argv[0]);	
	return(1);
    }

    port = atoi(argv[1]);

    printf("Starting receive...\n");
	    
    s = OpenConnector(0, port);

    if (s == -1)
    {
	perror("OpenConnector");
	exit(1);
    }
    
    while(1)
    {
        incomingSock = accept(s, &clientAddress, &addressLength);
        
	if (s == -1)
	{
	    perror("accept");
	    exit(1);
	}
				
	if (fork() == 0)
	{
	    printf("execing %s\n", argv[2]);
	    dup2(incomingSock, 0);
	    close(incomingSock);
	    execlp(argv[2], argv[2], argv[3], argv[4], argv[5], argv[6], 
		   argv[7], (char *) 0);
	    perror("execl failed");
	}
	          
	close(incomingSock);
    }
}  


