#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <sys/errno.h>
#include <memory.h>
#include <stdlib.h>
#include <netdb.h>

#ifdef __MAC__

/*	Macintosh headers... */

#include <unixlib.h>
#include <Events.h>
#include <OSEvents.h>
#include <OSUtils.h>

#endif

/*	End of Mac headers. */

#include "sockrtns.h"


#ifdef __MAC__

/*
 *	Mac setup....
 */
 
int CmdPeriod (void)
{
	EvQElPtr q;

	/* Should use techniques of TN263 for international cancelling */
	
	for (q = (EvQElPtr) GetEvQHdr()->qHead; q != NULL; q = (EvQElPtr) q->qLink)
		if ((q->evtQWhat == keyDown
				|| q->evtQWhat == autoKey)
				&& (q->evtQModifiers & cmdKey)
				&& !(q->evtQModifiers & (shiftKey+optionKey))
				&& (q->evtQMessage & charCodeMask) == '.')
		{
			FlushEvents (keyDownMask, 0);
			return (true);
		}
		
	return (false);
}

int MySpin (spin_msg msg,long data)
{
	// SpinCursor(1);		/* could spin cursor here like this */

	return CmdPeriod();		/* return 1 to abort, 0 otherwise */
}

void MacSocketsSetup()
{
    s_setspin (MySpin);
}

#endif

/*
 *	Routines for connecting to & accepting a connection from an address.
 */
 
int OpenConnection(char *hostName, int port)
{
    int		       	sock;
    struct hostent     	*hostEntry;
    struct sockaddr_in	inetAddress;
    unsigned long      	IPAddress;
	
    sock = socket(AF_INET,SOCK_STREAM,0);

    if (sock < 0)
	return(-1);

    hostEntry = gethostbyname(hostName);
	
    if (hostEntry == NULL)
    {
	IPAddress = inet_addr(hostName);
	if (IPAddress == -1)
	    return(-1);
    }
    else
	IPAddress = *((unsigned long *) hostEntry->h_addr);

    inetAddress.sin_family = PF_INET;
    inetAddress.sin_port = htons(port);
    inetAddress.sin_addr.s_addr = IPAddress;
	
    if (connect(sock, (struct sockaddr *) &inetAddress, sizeof(inetAddress)) < 0)
	return(-1);

    return(sock);
}

int OpenConnector(char *hostName, int port)
{
	int					sock;
	struct hostent		*hostEntry;
	struct sockaddr_in	inetAddress;
	unsigned long		IPAddress;
	
    sock = socket(AF_INET, SOCK_STREAM, 0);

	if (sock < 0)
		return(-1);

	if (hostName)
	{
		hostEntry = gethostbyname(hostName);

		if (hostEntry == NULL)
		{
			IPAddress = inet_addr(hostName);
			if (IPAddress == -1)
				return(-1);
		}
		else
			IPAddress = *((unsigned long *) hostEntry->h_addr);
	}
	else
		IPAddress = 0;

	inetAddress.sin_family = PF_INET;
	inetAddress.sin_port = htons(port);
    inetAddress.sin_addr.s_addr = IPAddress;

    if (bind(sock, (struct sockaddr *) &inetAddress, sizeof(inetAddress)) < 0)
    	return(-1);

	if (listen(sock, 1) < 0)
		return(-1);

    return(sock);
}

